"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateDict = void 0;
const cloneDeep_1 = __importDefault(require("lodash/cloneDeep"));
const merge_1 = __importDefault(require("lodash/merge"));
const updateDict = (prev, saveAsync) => (field, value, save = false, nested = '') => {
    let dataCopy = (0, cloneDeep_1.default)(prev);
    if (nested) {
        const nestedLayers = nested.split('.');
        const nestedData = nestedLayers
            .reverse()
            .reduce((acc, v) => ({ [v]: acc }), { [field]: value });
        dataCopy = (0, merge_1.default)(dataCopy, nestedData);
    }
    else {
        dataCopy[field] = value;
    }
    if (save) {
        saveAsync(dataCopy);
    }
    return dataCopy;
};
exports.updateDict = updateDict;
//# sourceMappingURL=helpers.js.map